import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * Your player. Control it with W,A,S,D. It's locked while you fire a missile. Space to fire.
 * 
 * @author Darren Reichler 
 * @version 5/23/16
 */
public class Crosshair extends Actor
{
    private int speed;
    public boolean reload = false;
    private int xcoord;
    private int ycoord;
    private int missilespawnx = 388;
    private int missilespawny = 597;
    private int timeline = 0;
    private int timelinewait = 0;
    private int rndroomx = 0;
    private int rndroomy = 0;
    public int badmissalive = 0;
    private boolean songwaitstartlevel = true;
    private int number = 1;
    
    public Crosshair(){
        speed = 4;
    }
    
    public Crosshair(int s){
        speed = s;
    }
    
    public void act(){
        xcoord = getX();
        ycoord = getY();
        move();
        shoot();
        //for five wave mode, un-comment spawnenemy and comment spawnenemy 2. Set to infinite by default
        //spawnenemy();
        spawnenemy2();
        playmusic();
    } 
    
    private void playmusic(){
        if (songwaitstartlevel == true){
            Greenfoot.playSound("start_level.wav");
            songwaitstartlevel = false;
        }
    }
    
    private void spawnenemy(){
        MyWorld mw = (MyWorld)getWorld();
        WaveNumber waveNumber = (WaveNumber)((ArrayList)mw.getObjects(WaveNumber.class)).get(0);
        if (timelinewait >= 900){
            timelinewait = 0;
            songwaitstartlevel = true;
            timeline++;
        }
        if (timeline == 0){ //wave 1
            spawnspefic(2);
            timeline++;
        } else if (timeline == 1){
            timelinewait++;
        } else if (timeline == 2){ //wave 2
            spawnspefic(4);
            waveNumber.nextwave();
            timeline++;
        } else if (timeline == 3){
            timelinewait++;
        } else if (timeline == 4){ //wave 3
            spawnspefic(7);
            waveNumber.nextwave();
            timeline++;
        } else if (timeline == 5){
            timelinewait++;
        } else if (timeline == 6){ //wave 4
            spawnspefic(11);
            waveNumber.nextwave();
            timeline++;
        } else if (timeline == 7){
            timelinewait++;
        } else if (timeline == 8){ //wave 5
            spawnspefic(16);
            waveNumber.nextwave();
            timeline++;
        } else if (timeline == 9){
            timelinewait++;
        } else if (timeline == 10){ //win
            Lose lose = new Lose();
            getWorld().addObject(lose, 388, 325); 
            Greenfoot.stop();
        }
    }
    
    private void spawnenemy2(){
        MyWorld mw = (MyWorld)getWorld();
        WaveNumber waveNumber = (WaveNumber)((ArrayList)mw.getObjects(WaveNumber.class)).get(0);
        if (timelinewait >= 900){
            timelinewait = 0;
            songwaitstartlevel = true;
            timeline--;
        }
        if (timeline == 0){
            spawnspefic(number);
            timeline++;
            number++;
            waveNumber.nextwave();
        } else if (timeline == 1){
            timelinewait++;
        }
    }
    
    private void spawnspefic(int num){
        badmissalive = num;
        for(int i=0; i<num; i++){ //middle number is how many enemies will spawn
            rndroomx = Greenfoot.getRandomNumber(776); // value from 0 to 775
            rndroomy = Greenfoot.getRandomNumber(31); // value from 0 to 30
            Missilebadd missilebad = new Missilebadd();
            getWorld().addObject(missilebad, rndroomx, rndroomy);
        }
    }
    
    private void move(){
        if (reload == false){
            if (Greenfoot.isKeyDown("A")){
                setRotation(180);
                move(speed);
            }
            else if (Greenfoot.isKeyDown("S")){
                setRotation(90);
                move(speed);
            }
            else if (Greenfoot.isKeyDown("D")){
                setRotation(0);
                move(speed);
            }
            else if (Greenfoot.isKeyDown("W")){
                setRotation(270);
                move(speed);
            }
        }
    }
    
    private void shoot(){
        if (reload == false && Greenfoot.isKeyDown("SPACE")){
            Missileplayer missileplayer = new Missileplayer();
            getWorld().addObject(missileplayer, 388, 597);
            Greenfoot.playSound("launch_bomb.wav");
            reload = true;
        }
    }
    
    public int getxcoord(){
        return xcoord;
    }
    
    public int getycoord(){
        return ycoord;
    }
}
