import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * The bad missiles that come from above, shoot them to advance
 * 
 * @author Darren Reichler 
 * @version 5/23/16
 */
public class Missilebadd extends Actor
{
    private int xcoord;
    private int ycoord;
    private int target;
    private boolean spawened = false;
    
    public void act(){
        xcoord = getX();
        ycoord = getY();
        MyWorld mw = (MyWorld)getWorld();
        ArrayList listOfGrounds = (ArrayList)mw.getObjects(Ground.class);
        Ground ground = (Ground)listOfGrounds.get(0);
        ArrayList listOfCrosshairs = (ArrayList)mw.getObjects(Crosshair.class);
        Crosshair crosshair = (Crosshair)listOfCrosshairs.get(0);
        ArrayList listOfNumberOfCities = (ArrayList)mw.getObjects(NumberOfCities.class);
        NumberOfCities numberOfCities = (NumberOfCities)listOfNumberOfCities.get(0);
        ArrayList listOfScoreText = (ArrayList)mw.getObjects(ScoreText.class);
        ScoreText scoreText = (ScoreText)listOfScoreText.get(0);
        if (!spawened){
            spawened = true;
            target = Greenfoot.getRandomNumber(650) + 63;
            turnTowards(target, ground.getycoord());
        }
        if (isTouching(Explosion.class)){
            Explosion explosion = new Explosion();
            getWorld().addObject(explosion, getX(), getY());
            scoreText.gimmepoints();
            die();
        }
        else if (isAtEdge() && ycoord > 100){
            getWorld().removeObject(this);
        }
        else if (ycoord > ground.getycoord()){
            Explosion explosion = new Explosion();
            getWorld().addObject(explosion, getX(), getY());
            numberOfCities.doneFuckedUp();
            die();
            
        } else {
            move(1);
            Trail trail = new Trail();
            getWorld().addObject(trail, getX(), getY());
        }
    }    
    
    private void die(){
        Greenfoot.playSound("missile_explode.wav");
        getWorld().removeObject(this);
    }
    
    public int getxcoord(){
        return xcoord;
    }
    
    public int getycoord(){
        return ycoord;
    }
}

/* to call
 * MyWorld mw = (MyWorld)getWorld();
   ArrayList listOfMissilebadds = (ArrayList)mw.getObjects(Missilebadd.class);
   Missilebadd missilebadd = (Missilebadd)listOfMissilebadds.get(0);
 */
